<template>
  <ob-form
    :form-data="formData"
    :form-model="formModel"
    :is-read-only="!isNew"
    @submit="onSubmitHandler"
    :is-active-element="formData['is_active']"
    okText="Добавить"
    cancelText="Отменить"
    @change-active="onChangeActive"    
  >
    <div class="row">
      <div class="col-xs-12">
        <ob-input
          :readonly="!isNew"
          v-model="formData.name"
          :label="dictionaryRu.modal.name"
          :placeholder="dictionaryRu.modal.name_placeholder"
          property="name"
          required
        />
      </div>
    </div>
    <div class="row">
      <div class="col-xs-6">
        <ob-input
          :readonly="!isNew"
          :label="dictionaryRu.modal.denomination"
          v-model="formData.denomination"
          :placeholder="dictionaryRu.modal.denomination_placeholder"
          property="denomination"
          required
        />
      </div>
      <div class="col-xs-6">
        <ob-input
          :readonly="!isNew"
          :label="dictionaryRu.modal.code"
          v-model="formData.code"
          :placeholder="dictionaryRu.modal.code_placeholder"
          property="code"
          @input="$emit('clearCodeValidation')"
          required
        />
      </div>
    </div>
  </ob-form>
</template>

<script>
import FormValidationMixin from "common-components/src/obComponents/obForm/FormValidationMixin";
import { required } from "vuelidate/lib/validators";
import cloneDeep from "clone-deep";
import ObForm from "common-components/src/obComponents/obForm";
import ObInput from "common-components/src/obComponents/obInput";
import { dictionary } from '@/translations/ru/dictionaries__services__service_measurement_units';

export default {
  name: "ServiceUnit",
  components: { ObForm, ObInput },
  mixins: [FormValidationMixin],
  props: {
    disabledForm: {
      type: Boolean,
      default: true
    },
    dataSource: {
      type: Object,
      required: true,
      default: () => {}
    },
    isValidCode: {
      type: Boolean,
      default: true
    }
  },
  data () {
    return {
      dictionaryRu: dictionary
    }
  },
  computed: {
    formModel() {
      return {
        uuid: {
          value: null
        },
        name: {
          value: '',
          validator: {
            required
          }
        },
        denomination: {
          value: '',
          validator: {
            required
          }
        },
        code: {
          value: '',
          validator: {
            required,
            checkCode: {
              method: this.checkCode,
              error: 'Единица измерения с таким кодом уже есть. Укажите уникальный код.'
            }
          }
        },
        'is_active': {
          value: false
        }
      }
    },
    isNew() {
      return !this.formData.uuid;
    }
  },
  methods: {
    checkCode() {
      return this.isValidCode;
    },
    async onChangeActive() {
      this.formData['is_active'] = !this.formData['is_active'];
      if (!this.isNew) {
        this.$emit('changeActive', this.formData['is_active']);
      }
    },

    onSubmitHandler() {
      console.log("this.formData", this.formData);
      const data = cloneDeep(this.formData);

      this.$emit("submit", { formData: data, model: this.formModel });
    }
  }
};
</script>
